/***************************************************************************
                          kfileedit.cpp  -  description
                             -------------------
    begin                : Sun May 12 2002
    copyright            : (C) 2002 by Zach Hobbs
    email                : zach@firstwavedesign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kfileedit.h"

KFileEdit::KFileEdit( QWidget * parent, QString fileName) 
  :QTextEdit( parent ) {

  if (fileName) {
    if(!openFile( fileName ))
      qDebug(fileName +" failure");
  } else {
    this->setReadOnly( true );
  }
       

}

KFileEdit::~KFileEdit() { }

void KFileEdit::clear() {
  QTextEdit::clear();
  file = QString::null;
  setReadOnly( true );
  setModified( false );

}

bool KFileEdit::openFile( QString fileName ) {

  QFile f(fileName);
  this->file = fileName;
  QString s;
  if ( f.open(IO_ReadOnly) ) {
    QTextStream t( &f );
    while ( !t.eof() ) {
      s += t.readLine() + "\n";
    }
    f.close();
  } else {
    this->setReadOnly( true );
    return false;
  }
  setText(s);

  
  setReadOnly( false );

  setModified( false );
  return true;

}

bool KFileEdit::saveFile( ) {
  
  QFile f(file);
  QString s;

  //if (!QFileInfo(f).isWritable())
  //  return false;

  if ( f.open(IO_WriteOnly) ) {
    QTextStream t( &f );
    t << this->text();
    f.close();
    setModified( false );
    return true ;
  } else
    return false;

}
