/***************************************************************************
                          kspelllist.h  -  description
                             -------------------
    begin                : Sun May 12 2002
    copyright            : (C) 2002 by Zach Hobbs
    email                : zach@firstwavedesign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KSPELLLIST_H
#define KSPELLLIST_H

#include <klistview.h>
#include <qdir.h>
#include <qfileinfo.h>
#include <qfile.h>
#include <qregexp.h>
#include <qprogressdialog.h>
#include <kapplication.h>
#include <qpopupmenu.h>
#include <qlistview.h>
#include <kmessagebox.h>

#include "kspelllistitem.h"

/**
  *@author Zach Hobbs
  */

class KSpellList : public KListView  {
Q_OBJECT
public: 
  KSpellList( QWidget* parent, const char *name );
  ~KSpellList();

  void buildList();

signals:
  void actionTaken( QString * );  
  void addQueue( QString * );

private:
  void buildGrimoire( QListViewItem * );
  void buildSpells( KListViewItem * );
  QPopupMenu *contextMenu;
  QString codexDir( int );

private slots:
  void popUpMenu( QListViewItem *, const QPoint &, int );
  void refreshList();
  void popUpAction( int );
  void itemExpanded( QListViewItem * );

};

#endif
