/***************************************************************************
                          kspellqueue.cpp  -  description
                             -------------------
    begin                : Tue Jan 21 2003
    copyright            : (C) 2003 by Zach Hobbs
    email                : zach@firstwavedesign.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kspellqueue.h"

KSpellQueue::KSpellQueue(QWidget *parent, const char *name ) : QWidget(parent,name) {

  QString queueFile("/var/log/sorcery/queue/install");
  QVBoxLayout *layout = new QVBoxLayout( this );

  layout->setMargin( 20 );
  layout->setSpacing( 20 );
  
  QHBoxLayout *buttonLayout = new QHBoxLayout( );
 
  buttonLayout->setMargin( 20 );
  buttonLayout->setSpacing( 20 );

  editBox = new KFileEdit( this, queueFile );
  layout->addWidget(editBox);

  layout->addLayout( buttonLayout );
  
  QPushButton * castButton = new QPushButton("Cast Queue", this );
  castButton->setMaximumWidth( 100 );
  
  saveButton = new QPushButton("Save Queue", this );
  saveButton->setMaximumWidth( 100 );

  saveButton->setDisabled( true ); 
 
  if (editBox->isReadOnly())
    castButton->setDisabled( true );
 
  buttonLayout->addWidget(saveButton);
  buttonLayout->addWidget(castButton);

  layout->setAlignment(Qt::AlignCenter);

  QObject::connect( castButton, SIGNAL( clicked() ),
		    this, SLOT( castQueue() ) );
 
  QObject::connect( saveButton, SIGNAL( clicked() ),
		    editBox, SLOT( saveFile() ) );

  QObject::connect( editBox, SIGNAL( modificationChanged( bool )),
		    this, SLOT( changeSaveButton( bool ) ) );
}
KSpellQueue::~KSpellQueue(){
}

void KSpellQueue::addItem( QString * spell ) {
  editBox->append(*spell);
}

void KSpellQueue::castQueue() {
  QString *castQueue = new QString("cast --queue");
  if (editBox->saveFile()) 
    emit actionTaken( castQueue );
  else
    qDebug("Couldn't write /var/log/sorcery/queue/install");
}

void KSpellQueue::changeSaveButton( bool modified ) {
  
  saveButton->setDisabled( !modified );
  
}
